#!/usr/bin/env python
# coding: utf-8

import numpy as np
from sklearn.manifold import TSNE
import matplotlib.pyplot as plt



import gensim.downloader as api
word2vec_model = api.load('glove-wiki-gigaword-50')

word2vec_model["beautiful"]

word2vec_model.most_similar("girl")


word2vec_model.most_similar(positive=['boy', 'queen'], negative=['girl'], topn=1)


vocab = ["boy", "girl", "man", "woman", "king", "queen", "banana", "apple", "mango", "fruit", "coconut", "orange"]

def plot(model):
    labels = []
    wordvecs = []

    for word in vocab:
        wordvecs.append(model[word])
        labels.append(word)
    
    tsne_model = TSNE(perplexity=3, n_components=2, init='pca', random_state=42)
    coordinates = tsne_model.fit_transform(wordvecs)

    x = []
    y = []
    for value in coordinates:
        x.append(value[0])
        y.append(value[1])
        
    plt.figure(figsize=(8,8)) 
    for i in range(len(x)):
        plt.scatter(x[i],y[i])
        plt.annotate(labels[i],
                     xy=(x[i], y[i]),
                     xytext=(2, 2),
                     textcoords='offset points',
                     ha='right',
                     va='bottom')
    plt.show()

plot(word2vec_model)

